
/**********************************************************/
/*                                                        */
/*  this demo shows how to include your own finite        */
/*  element geometry,solution and basic functions         */
/*  to render for example fliud flow phenomena            */
/*                                                        */
/**********************************************************/

#include <grape.h>

static float ftorx(x,y) float x,y; { return(cos(x)*(1. + 0.2*cos(y))); }
static float ftory(x,y) float x,y; { return(sin(x)*(1. + 0.2*cos(y))); }
static float ftorz(x,y) float x,y; { return(0.2*sin(y)); }


static float fhelx(x,y) float x,y; { return(sin(x)*y); }
static float fhely(x,y) float x,y; { return(cos(x)*y); }
static float fhelz(x,y) float x,y; { return(x/4.0); }


static float fsx(x,y) float x,y; { return(y); }
static float fsy(x,y) float x,y; { return(-sin(x)*0.125 + 0.875); }
static float fsz(x,y) float x,y; { return(cos(x)*0.125 + 0.375); }



main()
     
{ 
  TRIANG2D *tr;
  TEXTDEVICE *tdev;
  MANAGER *mgr;
  char name[80];
  

  printf("Display helix, torus or stick as triang2d instance [h,t,s]: ");
  scanf("%c",&name[0]);


  switch (name[0]) {
    case 't':
      tr = (TRIANG2D *)GRAPE(Triang2d, "explicit")
           ("torus", ftorx, ftory, ftorz, 0., 2.*M_PI, 0., 2.*M_PI, 40, 16);
      break;

    case 'h':
      tr = (TRIANG2D *)GRAPE(Triang2d, "explicit")
           ("helix", fhelx, fhely, fhelz, -2.*M_PI, 2.*M_PI, 0., 2., 28, 4);
      break;

    case 's':
      tr = (TRIANG2D *)GRAPE(Triang2d, "explicit")
           ("stick", fsx, fsy, fsz, 0., 2.*M_PI, 0., 1.0, 40, 10);
      break;
 
    default:
      exit(1);
  }


  mgr = (MANAGER *)GRAPE(Manager,"get-stdmgr")();

  GRAPE(mgr,"handle")(tr); 
}


