 
#include <grape.h>

extern FE2D *fe2d_isoline_disp();





static void fe2d_function(f,nr,bary,value)
     FE2D *f;
     int nr;
     VEC3 bary;
     float *value;
{
  float *value_ptr;
  int j;
  int *vert;

  value_ptr = (float *)f->data;
  vert = f->vertex[nr];

  for(j = 0;j < f->dimension_of_value;j++)
    value[j] = bary[0] * value_ptr[vert[0] * f->dimension_of_value + j] +
               bary[1] * value_ptr[vert[1] * f->dimension_of_value + j] +
               bary[2] * value_ptr[vert[2] * f->dimension_of_value + j];
}





/*  Diese Funktion berechnet das globale Minimum und Maximum der 
    Funktionswerte auf allen Knoten und in allen Schwerpunkten und
    uebergibt diese Werte dem Colorbar der isolinien-Methode.  */

FE2D *fe2d_set_min_max_send()
{ 
  FE2D *fe;
  float min = 1000000., max = -1000000., *values, value;
  VEC3 bary[4];
  int i, j, k;

  fe = (FE2D *)START_METHOD(G_INSTANCE);
  ASSURE(fe, "", END_METHOD(NIL));

  bary[0][0] = bary[0][1] = bary[0][2] = 1./3.;
  bary[1][0] = 1.; bary[1][1] = bary[1][2] = 0.;
  bary[2][1] = 1.; bary[2][0] = bary[2][2] = 0.;
  bary[3][2] = 1.; bary[3][0] = bary[3][1] = 0.;
  values = (float *)mem_alloc(sizeof(float) * fe->dimension_of_value);
  
  for (i=0; i<fe->number_of_elements; i++) 
    for (j=0; j<4; j++) {
      (*(fe->f))(fe,i,bary[j],values);
      if (fe->dimension_of_value > 1) { 
        value = 0.0;
        for (k=0; k<fe->dimension_of_value; k++)
          value += values[k] * values[k];
        if ((value = g_sqrt(value)) < min) min = value;
        if (value > max) max = value;
      }
      else {
        if (values[0] < min) min = values[0];
        if (values[0] > max) max = values[0];
      }
    }  

  (COLORBAR *)GRAPE(Colorbar, "set-default-min-max")
		   (min, max, fe2d_isoline_disp, "iso2dclb");

  mem_free(values,sizeof(float) * fe->dimension_of_value); 

  END_METHOD(fe)
}





main()

{
  MANAGER *mgr;
  FE2D *fe;
  TEXTDEVICE *tdev;
  char name[30];
   
  GRAPE(Fe2d ,"add-method")("set-min-max-send", fe2d_set_min_max_send);

  printf("2d finite element rendering (i.e. file smalldata/elast*.gr)\n ");
  printf("file : ");
  scanf("%s",name);
  
  tdev = (TEXTDEVICE *)GRAPE(InputFile,"new-instance")(name);
  ASSURE(tdev,"can't open file",exit(1));
  GRAPE(tdev,"set-stddev")();

  fe = (FE2D *)GRAPE(Fe2d,"read")();
  ASSURE(fe,"can't read 2d fe",exit(1));

  fe->f = fe2d_function;
  
  GRAPE(fe, "set-min-max-send")();

  mgr = (MANAGER *)GRAPE(Manager,"get-stdmgr")();

  GRAPE(mgr,"handle")(fe) ;
}





