
/***********************************************************************/
/*                            triang2d.c                               */
/*---------------------------------------------------------------------*/
/*                                                                     */
/*    Demoprogramm zur Triangulierung einer Pyramide aus vier Drei-    */
/*  ecken. Zur 3D-Ansicht den Koerper im 'Trans'-Menue rotieren.       */
/*  (Die Kanten werden mit der 'Send'-Methode "show-edges" schoener)   */
/*                                        RALPH SCHWOERER (27.07.95)   */
/***********************************************************************/

#include <grape.h>


main()
{  
  TRIANG2D *tr;
  MANAGER  *mgr;
  int      i;


  printf("\n\n*----------------------------------------------------*");
  printf(  "\n|                                                    |");
  printf(  "\n|   +  Change to grid-mode in the  'switches'        |");
  printf(  "\n|                                                    |");
  printf(  "\n|   +  Move the rulers in the  'trans' -menu         |");
  printf(  "\n|                                                    |");
  printf(  "\n*----------------------------------------------------*\n\n");


  /*---  Bereitstellen der Triang2d-Instanz:  ---*/
  tr = (TRIANG2D *)GRAPE(Triang2d, "new-instance") ("first grid");


  tr->number_of_points   = tr->max_number_of_points   = 5;
  tr->number_of_elements = tr->max_number_of_elements = 4;


  /*---  Allokieren von Speicher fuer die Arrays der Instanz:  ---*/
  tr->x         = (float *)mem_alloc(sizeof(float) * tr->number_of_points);
  tr->y         = (float *)mem_alloc(sizeof(float) * tr->number_of_points);
  tr->z         = (float *)mem_alloc(sizeof(float) * tr->number_of_points);
  tr->vertex    = (INT3 *)mem_alloc(sizeof(INT3) * tr->number_of_elements);
  tr->neighbour = (INT3 *)mem_alloc(sizeof(INT3) * tr->number_of_elements);


  /*---  Explizites Auffuellen der Arrays:  ---/*/
  tr->x[0] = -0.5;   tr->y[0] = 0.5;    tr->z[0] = 0.0;
  tr->x[1] = -0.5;   tr->y[1] = -0.5;   tr->z[1] = 0.0;
  tr->x[2] = 0.5;    tr->y[2] = -0.5;   tr->z[2] = 0.0;
  tr->x[3] = 0.5;    tr->y[3] = 0.5;    tr->z[3] = 0.0;
  tr->x[4] = 0.0;    tr->y[4] = 0.0;    tr->z[4] = 1.0;

  for (i=0; i<4; i++) {
    tr->vertex[i][0]    = i;
    tr->vertex[i][1]    = 4;
    tr->vertex[i][2]    = (i + 3) % 4;
    tr->neighbour[i][0] = (i + 3) % 4;
    tr->neighbour[i][1] = - 1;
    tr->neighbour[i][2] = (i + 1) % 4;
  }


  mgr = (MANAGER *)GRAPE(Manager, "get-stdmgr") ();

  GRAPE(mgr,"handle")(tr);
}





