/**********************************************************/
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*  this demo shows how to include your own finite        */
/*  element geometry,solution and basic functions         */
/*  to render for example fluid flow phenomena            */
/*                                                        */
/*                                                        */
/*                                                        */
/**********************************************************/

#include <grape.h>


main()
     
{ 

  TRIANG2D *tr;
  TIMESCENE *tsc;
  TEXTDEVICE *tdev;
  char path[60],filename[60];
  int i,start_time,end_time;
  float main_time,fact;
  MANAGER *mgr;
  
  printf("file format : dir/tr2d?.gr\n");
  printf("path <dir/flow_> : ");
  scanf("%s",path);
  printf("\n");
  printf("start time , end time : ");
  scanf("%d %d" , &start_time, &end_time);
  printf("\n");
  printf("factor (time = step * fact) : ");
  scanf("%f" , &fact);
  printf("\n");

  tsc = (TIMESCENE *)GRAPE(TimeScene,"new-instance")("tsc move");

  for(i=start_time;i<=end_time;i++) {
    
    sprintf(filename,"%s%d.gr",path,i);
    main_time = (i-start_time)*fact;
    printf("read %s (time : %f)\n",filename,main_time);

    tdev = (TEXTDEVICE *)GRAPE(InputFile,"new-instance")(filename);
    ASSURE(tdev,"can't open file",exit(1));
    GRAPE(tdev,"set-stddev")();
    tr = (TRIANG2D *)GRAPE(Triang2d,"read")();
    ASSURE(tr,"can't read 2d tr",exit(1));
    tsc->dynamic = (tsc->dynamic == NIL) ?
      (INSTANCE *)GRAPE(TimeStep,"put")(tr,tr,main_time) :
	(INSTANCE *)GRAPE(tsc->dynamic,"put")(tr,tr,main_time);
   
  }

  mgr = (MANAGER *)GRAPE(Manager,"get-stdmgr")();
  GRAPE(mgr,"handle")(tsc);

  

}









