/**********************************************************/
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*  this demo shows how to include your own finite        */
/*  element geometry,solution and basic functions         */
/*  to render for example fliud flow phenomena            */
/*                                                        */
/*                                                        */
/*                                                        */
/**********************************************************/

#include <grape.h>

  OUTPUTFILE *tdev;
  INPUTFILE *tdev1;
  GRAPHICDEVICE *dev ;

static MATRIX44 perspec = {{1.0,0.0,0.0,0.0},
		           {0.0,1.0,0.0,0.0},
		           {0.0,0.0,1.0,0.0},
		           {0.0,0.0,0.0,1.0}};


INSTANCE *root_dboff_send()

{ INSTANCE *i;
  GRAPHICDEVICE *dev;
  static int flag = 0;

  i = (INSTANCE *)START_METHOD(G_INSTANCE);
  dev = (GRAPHICDEVICE *)GRAPE(GraphicDevice,"get-stddev")();
 
  dev->attribute(G_MODE_SET,G_DOUBLEBUFFER,&flag);

  END_METHOD(i);

}


main()
     
{ 

  extern FE3D *fe3d_read_ebsel_3d();
  extern INSTANCE *root_ebs_switch_send();
 
  SCENE *as;
  FE3D *fe;
  MANAGER *mgr;
  GRAPHICDEVICE *dev;
  
  float zrange;
  char name[60];
  int ir[4] ;
  void dumfunk();

  printf("rendering of 3d navier-stokes (i.e. file smalldata/*.dat): \n");
  printf("file : ");
  scanf("%c",&name[0]);
  if(name[0] != '\n') scanf("%s",&name[1]);
 
  printf("zrange (e.g. 2.0): ");
  scanf("%f",&zrange);
  perspec[2][2] = 1/zrange;


  GRAPE(Fe3d,"add-method")("read-ebsel-3d",fe3d_read_ebsel_3d);
  GRAPE(Root,"add-method")("ebs-switch-send",root_ebs_switch_send);
  GRAPE(Root,"add-method")("dboff-send",root_dboff_send);

  fe = (FE3D *)GRAPE(Fe3d,"read-ebsel-3d")("fe3d",name,1);

  ASSURE(fe,"can't read ebsel 3d fe",exit(1));

  printf(".............................................................\n\n");
  printf("You may use the read button to read a 2d triangulation.\n");
  printf("This geometry then can be moved as a test volume boundary.\n");
  printf("(i.e. open dev 'smalldata/ball.gr') \n\n");
  printf(".............................................................\n");
    
  dev = (GRAPHICDEVICE *)GRAPE(GraphicDevice,"get-stddev")();

  dev->transform(G_MODE_POST,G_MATRIX_PROJECT,perspec);  
  
  as = (SCENE *)GRAPE(Scene,"new-instance")("cube") ;
  as->object = (INSTANCE *)fe ;
  mgr = (MANAGER *)GRAPE(Manager,"get-stdmgr")();

  GRAPE(mgr,"handle")(as) ; 

}



