/**********************************************************/
/*                                                        */
/*                                                        */
/*                                                        */
/*                                                        */
/*  this demo shows how to include your own finite        */
/*  element geometry,solution and basic functions         */
/*  to render for example fliud flow phenomena            */
/*                                                        */
/*                                                        */
/*                                                        */
/**********************************************************/

#include <grape.h>

float main_time;  
int frac_time;



  OUTPUTFILE *tdev;
  INPUTFILE *tdev1;
  GRAPHICDEVICE *dev ;

static MATRIX44 perspec = {{1.0,0.0,0.0,0.0},
		           {0.0,1.0,0.0,0.0},
		           {0.0,0.0,1.0,0.0},
		           {0.0,0.0,0.0,1.0}};

FE3D *fe3d_pressure_velo()

{

  FE3D *fe;

  fe  = (FE3D *)START_METHOD(G_INSTANCE);
  ASSURE(fe,
	 "pressure-velo : can't manage classes",
	 END_METHOD(NIL));
  fe->dimension_of_value = (fe->dimension_of_value == 3)? 1 : 3;
  fe->polynomial_order = (fe->polynomial_order == 2)? 1 : 2;
  
  END_METHOD(fe);

}

main()
     
{ 

static float white[3] = {1.0,1.0,1.0};
  extern FE3D *fe3d_read_ebsel_3d();
  
  TIMESCENE *tsc;
  SCENE *as;
  FE3D *fe,*fe_first;
  MANAGER *mgr;
  BUTTON *butpv;
  GRAPHICDEVICE *dev;
   
  float zrange,fact;
  int start_time,end_time;
  char name[50],path[40];
  int ir[4] ;
  void dumfunk();

  printf("zrange (e.g. 2.0): ");
  scanf("%f",&zrange);
  perspec[2][2] = 1/zrange;


  GRAPE(Fe3d,"add-method")("read-ebsel-3d",fe3d_read_ebsel_3d);
  GRAPE(Fe3d,"add-method")("pressure-velo",fe3d_pressure_velo);
  
  tsc = (TIMESCENE *)GRAPE(TimeScene,"new-instance")("tsc test");
  printf("Path <dir/flow_>: ");
  scanf("%s",path);
  printf("start time , end time :");
  scanf("%d %d" , &start_time, &end_time);
  printf("\n");
  printf("factor (time = step * fact) : ");
  scanf("%f" , &fact);
  printf("\n");
  for(frac_time = start_time;frac_time<=end_time;frac_time++) {

    main_time = fact * (frac_time - start_time);
    sprintf(name,"%spre%d.dat",path,frac_time);
    printf("read %s\n",name);
    if(frac_time == -1) break;

    if(tsc->dynamic == NIL) {
      fe_first = (FE3D *)GRAPE(Fe3d,"read-ebsel-3d")
                      ("fe3d","/net/xtreme/mnt/eberhard/saeule/mart/gmres/post308.dat",1);
      ASSURE(fe_first,"can't read ebsel 3d fe",exit(1));
      fe = (FE3D *)GRAPE(Fe3d,"read-ebsel-3d")("fe3d",name,0);
      ASSURE(fe,"can't read ebsel 3d fe",exit(1));
      fe->x = fe_first->x;
      fe->y = fe_first->y;
      fe->z = fe_first->z;
      fe->vertex = fe_first->vertex;
      fe->neighbour = fe_first->neighbour;
      fe_first = fe;
      tsc->dynamic = (INSTANCE *)GRAPE(TimeStep,"put")(fe,fe,main_time);
    }
    else {
      fe = (FE3D *)GRAPE(Fe3d,"read-ebsel-3d")("fe3d",name,0);
      ASSURE(fe,"can't read ebsel 3d fe",exit(1));
      fe->x = fe_first->x;
      fe->y = fe_first->y;
      fe->z = fe_first->z;
      fe->vertex = fe_first->vertex;
      fe->neighbour = fe_first->neighbour;
      tsc->dynamic = (INSTANCE *)GRAPE(tsc->dynamic,"put")(fe,fe,main_time);
    }
  } 
  
  dev = (GRAPHICDEVICE *)GRAPE(GraphicDevice,"get-stddev")();
  dev->transform(G_MODE_POST,G_MATRIX_PROJECT,perspec);  
  dev->attribute(G_MODE_SET,G_BACKGROUND_COLOR,white);

  mgr = (MANAGER *)GRAPE(Manager,"get-stdmgr")();

  butpv = (BUTTON *)GRAPE(Button,"new-instance")
    ("pressure-velo",NIL,"pressure-velo");
  GRAPE(butpv,"set-pref-size")(6.,1.);
  GRAPE(mgr,"add-inter")(butpv);

  GRAPE(mgr,"handle")(tsc) ; 


}



