#include <grape.h>


SUPROP *get_suprop(name,a1,a2,a3,d1,d2,d3,s1,s2,s3,exp,scal,trans)

char *name;
float a1,a2,a3,d1,d2,d3,s1,s2,s3,exp,scal,trans;

{

SUPROP *sup;

  sup = (SUPROP *)GRAPE(Suprop,"new-instance")(name);
  sup->suprop_dev.ambient[0] = a1*scal;
  sup->suprop_dev.ambient[1] = a2*scal;
  sup->suprop_dev.ambient[2] = a3*scal;
  sup->suprop_dev.diffuse[0] = d1*scal;
  sup->suprop_dev.diffuse[1] = d2*scal;
  sup->suprop_dev.diffuse[2] = d3*scal;
  sup->suprop_dev.specular[0] = s1*scal;
  sup->suprop_dev.specular[1] = s2*scal;
  sup->suprop_dev.specular[2] = s3*scal;
  sup->suprop_dev.specular_exp = exp;
  sup->suprop_dev.transparency = trans;
  return(sup);

}

main()
     
{ 

  TRIANG2D *tr1,*tr2,*tr3;
  TIMESCENE *tsc1,*tsc2,*tsc3;
  TEXTDEVICE *tdev;
  char name[60],filename1[60],filename2[60],filename3[60];
  int step,i,j;
  float main_time;
  MANAGER *mgr;
  GRAPHICDEVICE *dev;
  SUPROP *magenta,*gold,*red,*blue;


  tsc1 = (TIMESCENE *)GRAPE(TimeScene,"new-instance")("tsc1");
  tsc2 = (TIMESCENE *)GRAPE(TimeScene,"new-instance")("tsc2");
  tsc3 = (TIMESCENE *)GRAPE(TimeScene,"new-instance")("tsc3");

  for(i=2;i<10;i++) {
    
    printf("timestep : ");
    step = i-2;
    sprintf(filename1,"smalldata/moveballs/b1%d.gr",i);
    sprintf(filename2,"smalldata/moveballs/b2%d.gr",i);
    sprintf(filename3,"smalldata/moveballs/b3%d.gr",i);
    main_time = step * 0.25;
    printf("read %s %s %s\n",filename1,filename2,filename3);

    tdev = (TEXTDEVICE *)GRAPE(InputFile,"new-instance")(filename1);
    ASSURE(tdev,"can't open file",exit(1));
    GRAPE(tdev,"set-stddev")();
    tr1 = (TRIANG2D *)GRAPE(Triang2d,"read")();
    ASSURE(tr1,"can't read 2d tr",exit(1));

    tdev = (TEXTDEVICE *)GRAPE(InputFile,"new-instance")(filename2);
    ASSURE(tdev,"can't open file",exit(1));
    GRAPE(tdev,"set-stddev")();
    tr2 = (TRIANG2D *)GRAPE(Triang2d,"read")();
    ASSURE(tr2,"can't read 2d tr",exit(1));

    tdev = (TEXTDEVICE *)GRAPE(InputFile,"new-instance")(filename3);
    ASSURE(tdev,"can't open file",exit(1));
    GRAPE(tdev,"set-stddev")();
    tr3 = (TRIANG2D *)GRAPE(Triang2d,"read")();
    ASSURE(tr3,"can't read 2d tr",exit(1));

    tsc1->dynamic = (tsc1->dynamic == NIL) ?
      (INSTANCE *)GRAPE(TimeStep,"put")(tr1,tr1,main_time) :
	(INSTANCE *)GRAPE(tsc1->dynamic,"put")(tr1,tr1,main_time);
    tsc2->dynamic = (tsc2->dynamic == NIL) ?
      (INSTANCE *)GRAPE(TimeStep,"put")(tr2,tr2,main_time) :
	(INSTANCE *)GRAPE(tsc2->dynamic,"put")(tr2,tr2,main_time);
    tsc3->dynamic = (tsc3->dynamic == NIL) ?
      (INSTANCE *)GRAPE(TimeStep,"put")(tr3,tr3,main_time) :
	(INSTANCE *)GRAPE(tsc3->dynamic,"put")(tr3,tr3,main_time);
  }

  magenta = get_suprop("magenta",.4,.0,.4,.3,.0,.3,.9,.9,.95,30.,1.0,1.0);
  gold  = get_suprop("gold"   ,.4,.2,.0,.9,.5,.0,.7,.7,.0,10.,1.0,1.0);
  red = get_suprop("red"      ,.3,.0,.0,.5,.0,.0,.6,.6,.6,30.,1.0,1.0);
  blue = get_suprop("blue"    ,.0,.1,.3,.0,.2,.6,.6,.6,.6,30.,1.0,1.0);

  tsc1->next_scene = (SCENE *)tsc2;
  tsc2->next_scene = (SCENE *)tsc3;
  tsc2->sync = 1;
  tsc3->sync = 1;
  tsc1->sync = 1;
  tsc1->suprop = red; 
  tsc2->suprop = magenta; 
  tsc3->suprop = gold; 
  
  mgr = (MANAGER *)GRAPE(Manager,"get-stdmgr")();
  GRAPE(mgr,"handle")(tsc1);
  dev = (GRAPHICDEVICE *)GRAPE(GraphicDevice,"get-stddev")();


}




